#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/time.h>
#define INCL_DOS
#include <os2.h>
#ifdef _THREAD_SAFE
#include <pthread.h>
#include "pthread_private.h"

int pthread_cancel(pthread_t thread)
{
    int counter;

    if(thread) {
        if(thread->cancel_state == PTHREAD_CANCEL_ENABLE) {
            if(thread->cancel_type == PTHREAD_CANCEL_ASYNCHRONOUS) {
                /* This may need to be enhanced... this is a brutal kill */
                DosKillThread((TID)thread->threadid);
            } else {
                thread->cancel_pending = TRUE;
            }
        }
    }
    return 0;
}

int pthread_setcancelstate(int state, int *oldstate)
{
    pthread_t thread = pthread_self();

    if(state != PTHREAD_CANCEL_ENABLE && state != PTHREAD_CANCEL_DISABLE)
        return EINVAL;
    if(thread) {
        if(oldstate)
            *oldstate = thread->cancel_state;
        thread->cancel_state = state;
    }
    return 0;
}

int pthread_setcanceltype(int type, int *oldtype)
{
    pthread_t thread = pthread_self();

    if(type != PTHREAD_CANCEL_DEFERRED && type != PTHREAD_CANCEL_ASYNCHRONOUS)
        return EINVAL;
    if(thread) {
        if(oldtype)
            *oldtype = thread->cancel_type;
        thread->cancel_type = type;
    }
    return 0;
}

int pthread_testcancel(void)
{
    pthread_t thread = pthread_self();

    if(thread && thread->cancel_pending)
        pthread_exit(PTHREAD_CANCELED);
    return 0;
}
#endif